<?php
if(class_exists('ACF')) {

	// Custom folder path for ACF json save point
	function real_parent_acf_json_save_point($path) {

		$current_theme = wp_get_theme();
		$text_domain = $current_theme->get('TextDomain');
		if($text_domain == 'real-theme') {
			$path = get_template_directory() . '/functions/acf/acf-json';
		} else if($text_domain == 'real-child') {
			$path = get_stylesheet_directory() . '/functions/acf/acf-json';
		}
		
		// return
		return $path;
	}
	add_filter('acf/settings/save_json', 'real_parent_acf_json_save_point');

	// Load ACF json files
	function real_parent_acf_json_load_point($paths) {

		// remove original path (optional)
		// unset($paths[0]);

		// append paths
		$paths[] = get_template_directory() . '/functions/acf/acf-json';
		$paths[] = get_stylesheet_directory() . '/functions/acf/acf-json';

		// return
		return $paths;
	}
	add_filter('acf/settings/load_json', 'real_parent_acf_json_load_point');


	// Hide ACF from menu
	function real_hide_acf_admin() {

		// Get the current environment
		$wp_env = $_ENV['WP_ENV'];
		
		// check if is 'production' environment
		if ($wp_env == 'production') {
			// hide the acf menu item 
			return false;
		} else {
			// show the acf menu item 
			return true;
		}
	}
	add_filter('acf/settings/show_admin', 'real_hide_acf_admin');

	
	// Google maps
	function real_acf_google_map_api($api)
	{
		$api['key'] = 'AIzaSyC0iFDV1erqxd5DsZeffJoeFMPs-9hONSk';
		return $api;
	}
	add_filter('acf/fields/google_map/api', 'real_acf_google_map_api');

}