<?php

/**
 * Register Post Type: event
 */
function ri_register_cpt_event() {

	$labels = [
		"name"              => __( "Events", "realideas" ),
		"singular_name"     => __( "Event", "realideas" ),
	];

	$args = [
		"label"                 => __( "Events", "realideas" ),
		"labels"                => $labels,
		"description"           => "",
		"public"                => true,
		"publicly_queryable"    => true,
		"exclude_from_search"	=> false,
		"show_ui"               => true,
		"show_in_rest"          => true,
		"has_archive"           => false,
		"show_in_menu"          => true,
		"show_in_nav_menus"     => true,
		"delete_with_user"      => false,
		"exclude_from_search"   => false,
		"capability_type"       => "post",
		"map_meta_cap"          => true,
		"hierarchical"          => false,
		"rewrite"               => [ "slug" => "whats-on", "with_front" => true ],
		"menu_icon"             => "dashicons-tickets-alt",
		"supports"              => [ "title", "thumbnail" ],
		"show_in_graphql"       => false,
	];

	register_post_type( "event", $args );
	
}
add_action( 'init', 'ri_register_cpt_event' );


/**
 * Register Taxonomy: event-format Eventbrite "Type"
 */
function ri_register_tax_event_format() {

	$labels = [
		"name" 				=> __( "Format", "realideas" ),
		"singular_name" 	=> __( "Format", "realideas" ),
	];

	$args = [
		"label" 				=> __( "Format", "realideas" ),
		"labels" 				=> $labels,
		"public" 				=> true,
		"publicly_queryable" 	=> true,
		"hierarchical" 			=> true,
		"show_ui" 				=> true,
		"show_in_menu" 			=> true,
		"show_in_nav_menus" 	=> true,
		"query_var" 			=> true,
		"rewrite" 				=> [ 'slug' => 'event-format', 'with_front' => true, ],
		"show_admin_column" 	=> false,
		"show_in_rest" 			=> true,
		"rest_base" 			=> "event-format",
		"rest_controller_class" => "WP_REST_Terms_Controller",
		"show_in_quick_edit" 	=> false,
		"show_in_graphql" 		=> false,
		"meta_box_cb"			=> false,
	];

	register_taxonomy( "event-format", "event", $args );

}
add_action( 'init', 'ri_register_tax_event_format' );


/**
 * Register Taxonomy: event-category Eventbrite "Categories & Subcategories"
 */
function ri_register_tax_event_category() {

	$labels = [
		"name" 				=> __( "Category", "realideas" ),
		"singular_name" 	=> __( "Category", "realideas" ),
	];

	$args = [
		"label" 				=> __( "category", "realideas" ),
		"labels" 				=> $labels,
		"public" 				=> true,
		"publicly_queryable" 	=> true,
		"hierarchical" 			=> true,
		"show_ui" 				=> true,
		"show_in_menu" 			=> true,
		"show_in_nav_menus" 	=> true,
		"query_var" 			=> true,
		"rewrite" 				=> [ 'slug' => 'event-category', 'with_front' => true, ],
		"show_admin_column" 	=> false,
		"show_in_rest" 			=> true,
		"rest_base" 			=> "event-category",
		"rest_controller_class" => "WP_REST_Terms_Controller",
		"show_in_quick_edit" 	=> false,
		"show_in_graphql" 		=> false,
		"meta_box_cb"			=> false,
	];

	register_taxonomy( "event-category", "event", $args );

}
add_action( 'init', 'ri_register_tax_event_category' );


/**
 * Register Taxonomy: event-organiser
 */
function ri_register_tax_event_organiser() {

	$labels = [
		"name" 				=> __( "Organiser", "realideas" ),
		"singular_name" 	=> __( "Organiser", "realideas" ),
	];

	$args = [
		"label" 				=> __( "Organiser", "realideas" ),
		"labels" 				=> $labels,
		"public" 				=> true,
		"publicly_queryable" 	=> true,
		"hierarchical" 			=> true,
		"show_ui" 				=> true,
		"show_in_menu" 			=> true,
		"show_in_nav_menus" 	=> true,
		"query_var" 			=> true,
		"rewrite" 				=> [ 'slug' => 'event-organiser', 'with_front' => true, ],
		"show_admin_column" 	=> false,
		"show_in_rest" 			=> true,
		"rest_base" 			=> "event-organiser",
		"rest_controller_class" => "WP_REST_Terms_Controller",
		"show_in_quick_edit" 	=> false,
		"show_in_graphql" 		=> false,
		"meta_box_cb"			=> false,
	];

	register_taxonomy( "event-organiser", "event", $args );

}
add_action( 'init', 'ri_register_tax_event_organiser' );




// deprecated
/**
 * Register Taxonomy: event-venue
 */
function ri_register_tax_event_venue() {

	$labels = [
		"name" 				=> __( "Venues", "realideas" ),
		"singular_name" 	=> __( "Venue", "realideas" ),
	];

	$args = [
		"label" 				=> __( "venues", "realideas" ),
		"labels" 				=> $labels,
		"public" 				=> true,
		"publicly_queryable" 	=> true,
		"hierarchical" 			=> true,
		"show_ui" 				=> true,
		"show_in_menu" 			=> true,
		"show_in_nav_menus" 	=> true,
		"query_var" 			=> true,
		"rewrite" 				=> [ 'slug' => 'venue', 'with_front' => true, ],
		"show_admin_column" 	=> false,
		"show_in_rest" 			=> true,
		"rest_base" 			=> "venue",
		"rest_controller_class" => "WP_REST_Terms_Controller",
		"show_in_quick_edit" 	=> false,
		"show_in_graphql" 		=> false,
		"meta_box_cb"			=> false,
	];

	register_taxonomy( "event-venue", "event", $args );

}
add_action( 'init', 'ri_register_tax_event_venue' );