<?php get_header();

$post_id = $post->ID;
$fields = get_fields($post_id);

// print_r($fields);

$eventbrite_event_id = $fields['eb_event_id'];
$title = $post->post_title;
$description = isset($fields['full_description']) ? $fields['full_description'] : null;
$start_date = $fields['start_datetime'];
$end_date = $fields['end_datetime'];
$soldout = $fields['sold_out'];
$is_event_series = $fields['is_event_series'];
$series_dates = isset($fields['event_series_dates']) ? $fields['event_series_dates'] : null;
$venue_name = $fields['event_venue']['venue_name'];
$location = $fields['event_venue']['venue_location'];
$featured_image = isset($fields['featured_image']) ? $fields['featured_image'] : null; ?>




<main class="event">

	<section class="event-main container-wrap">
		<div class="container">

		    <div class="featured-image">
				<?php if($featured_image) { ?>
					<img class="featured" src="<?php echo $featured_image; ?>" alt="<?php echo $title; ?>" />
				<?php } ?>
			</div>

			<div class="header">
				<h1><?php echo $title; ?></h1>

                <div class="booking">
                    <?php if($soldout == true) { ?>
                        <p class="soldout-notify">This event has sold out.</p>
                    <?php } else if($fields['event_object_type'] == 'eventbrite') { ?>
                        <noscript><a href="https://www.eventbrite.co.uk/e/final-test-event-tickets-<?php echo $eventbrite_event_id; ?>" rel="noopener noreferrer" target="_blank">Buy Tickets on Eventbrite</a></noscript>
                        <button id="eventbrite-widget-modal-trigger-<?php echo $eventbrite_event_id; ?>" class="btn event-book" type="button">Book now</button>
                    <?php } else if($fields['event_object_type'] == 'custom') { 
                        if($fields['custom_booking_url']) { ?>
                            <a href="<?php echo $fields['custom_booking_url']; ?>" target="_blank" class="btn event-book" type="button">Book now</a>
                        <?php }
                    } ?>
                </div>

            </div>

            <div class="dates">
                <?php if($venue_name) { ?>
                    <p class="venue"><strong>Venue:</strong> <?php echo $venue_name; ?></p>
                <?php } ?>
                
                
                <?php if($is_event_series == true) {
                    $today = strtotime(date('Y/m/d')); ?>

                    <div class="event-dates">
                        <h4>Upcoming Dates:</h4>
                        <?php $dates_array = array(); ?>

                        <?php foreach($series_dates as $date) {

                            $sdate = strtotime($date['event_series_start_datetime']);
                            if($sdate > $today) {
                                $single_date = array(
                                    'start' => $date['event_series_start_datetime'],
                                    'end'	=> $date['event_series_end_datetime'],
                                );
                                array_push($dates_array, $single_date);
                            } ?>
                            
                        <?php } 

                        sort($dates_array); 
                        
                        foreach($dates_array as $d) { ?>

                            <div class="event-date">
                                <span class="date"><?php echo date("D, jS M, g:ia", strtotime($d['start'])) . ' - ' . date("g:ia", strtotime($d['end'])); ?></span>
                            </div>

                        <?php } ?>

                    </div>

                <?php } else { ?>
                    <p class="date"><?php echo date("D, jS M Y, g:ia", strtotime($start_date)); ?></p>
                <?php } ?>

            </div>

            <div class="description">
                <?php if($description) {
                    echo $description;
                } ?>
            </div>

		</div>
	</section>

	<!-- <section class="venue container-wrap">
		<div class="container">

            <?php if($location){ ?>
                <div class="map">
                    <?php get_template_part('template-parts/components/map', '', array(
                        'location'		=> $location,
                        'zoom'			=> 12,
                        'fullscreen'	=> true,
                        'init'			=> false,
                    )); ?>
                </div>
            <?php } ?>

		</div>
	</section> -->

	<!-- <section class="related-events container-wrap">
		<div class="container">

		<h3 class="section-title">See what else is on...</h3>
				
		<?php // related posts
		$q_object = get_queried_object();
		echo get_template_part('template-parts/components/related-posts', null, array(
			'queried_object'     => $q_object,
		)); ?>

		</div>
	</section> -->

</main>


<script>
	jQuery(document).ready(function($) {

		$('.info-header').on('click', function() {

			$(this).parent('.info').toggleClass('active');

		});
		
		$('.info-header').one('click', function() {

			if($(this).parent('.info').hasClass("venue")) {
				$('.acf-map').each(function(){
					var map = initMap( $(this) );
				});
			}

		});
	});
</script>


<script src="https://www.eventbrite.com/static/widgets/eb_widgets.js"></script>
<script type="text/javascript">
    var exampleCallback = function() {
        console.log('Order complete!');
    };

    window.EBWidgets.createWidget({
        widgetType: 'checkout',
        eventId: <?php echo $eventbrite_event_id; ?>,
        modal: true,
        modalTriggerElementId: 'eventbrite-widget-modal-trigger-' + '<?php echo $eventbrite_event_id; ?>',
        onOrderComplete: exampleCallback
    });
</script>

<?php get_footer();
