<?php
/**
 * Template Name: Whats On
 * 
 */

get_header();

// get query parameters
$q_event = $_GET['q'] ?? null;
$q_date = $_GET['date'] ?? null;
$q_date_range = $_GET['date_range'] ?? null;


// dates
$all = ($q_date == 'all') ? 'checked' : null;
$all = ($q_date == null) ? 'checked' : $all;
$today = ($q_date == 'today') ? 'checked' : null;
$week = ($q_date == 'week') ? 'checked' : null;
$month = ($q_date == 'month') ? 'checked' : null; ?>

<main>

    <div class="container-wrap" id="events-search" >
        <div class="container">

            <form id="search-form">
                <div class="search-name">
                    <input type="text" name="q" id="event-name" value="<?php echo $q_event; ?>" placeholder="Search for Events" />
                    <ion-icon name="search-outline"></ion-icon>
                </div>
            
                <div class="search-dates">
                    <div class="presets">
                        <input type="radio" id="all" name="date" value="all" <?php echo $all; ?>>
                        <label class="date-label" for="all">All</label>
                        <input type="radio" id="today" name="date" value="today" <?php echo $today; ?>>
                        <label class="date-label" for="today">Today</label>
                        <input type="radio" id="week" name="date" value="week" <?php echo $week; ?>>
                        <label class="date-label" for="week">This Week</label>
                        <input type="radio" id="month" name="date" value="month" <?php echo $month; ?>>
                        <label class="date-label" for="month">This Month</label>
                    </div>
                    <div class="date-range">
                        <div class="date-range-options">
                            <label for="datepicker" >or Select dates:</label>
                            <span id="picker-clear" class="hide">x clear</span>
                        </div>
                        <input type="text" name="date_range" id="datepicker" />
                    </div>
                </div>

                <div class="filters">
                    <div class="inner-wrap">

                    </div>
                </div>

            </form>

        </div>

    </div>

    <?php // event grid
    $posts_config = array(
        'post_type' 		=> 'event',
        'posts_per_page' 	=> -1,
        'suppress_filters'  => false,
        'orderby' 			=> 'meta_value',
        'meta_key' 			=> 'start_datetime',
        'order' 			=> 'ASC',
        's' 				=> $q_event,
        'meta_query' 		=> array(
            'relation'  => 'AND',
            array(
                'key'       => 'event_status',
                'compare'   => '!=',
                'value'     => 'draft'
            ),
            array(
                'key'       => 'event_visibility',
                'compare'   => '=',
                'value'     => true
            )
        ),
        'tax_query'         => array(),
    );
    // today query
    if($q_date == 'today') {
        $date_today = date("Y/m/d");
        $meta_query = array(
            'relation'  => 'OR',
            array(
                'key'		=> 'start_datetime',
                'compare'	=> '=',
                'value'		=> $date_today,
                'type'      => 'DATE'
            ),
            array(
                'key'		=> 'event_series_dates_$_event_series_start_datetime',
                'compare'	=> '=',
                'value'		=> $date_today,
                'type'      => 'DATE'
            ),
        );
        array_push($posts_config['meta_query'], $meta_query);
    }
    // range query presets
    if($q_date == 'week' || $q_date == 'month') {
        
        $date_range = rangeDate(date("Y/m/d"), $q_date);
        $meta_query = array(
            array(
                'relation'  => 'OR',
                array(
                    'key'		=> 'start_datetime',
                    'compare'	=> 'BETWEEN',
                    'value'		=> array($date_range['start'], $date_range['end']),
                    'type'      => 'DATE'
                ),
                array(
                    'key'		=> 'event_series_dates_$_event_series_start_datetime',
                    'compare'	=> 'BETWEEN',
                    'value'		=> array($date_range['start'], $date_range['end']),
                    'type'      => 'DATE'
                ),
            ),
        );
        array_push($posts_config['meta_query'], $meta_query);
    }
    // range query picker
    if($q_date_range) {
        
        $s_date = substr($q_date_range, 0, 10);
        $e_date = substr($q_date_range, 13, 23);

        $meta_query = array(
            array(
                'relation'  => 'OR',
                array(
                    'key'		=> 'start_datetime',
                    'compare'	=> 'BETWEEN',
                    'value'		=> array($s_date, $e_date),
                    'type'      => 'DATE'
                ),
                array(
                    'key'		=> 'event_series_dates_$_event_series_start_datetime',
                    'compare'	=> 'BETWEEN',
                    'value'		=> array($s_date, $e_date),
                    'type'      => 'DATE'
                ),
            ),
            
        );
        array_push($posts_config['meta_query'], $meta_query);
    } ?>

    <section class="container-wrap" style="margin-bottom: 140px">
        <div class="container">
    
            <?php echo get_template_part('template-parts/components/posts-grid', null, array(
                'query'     => $posts_config,
            )); ?>
        
        </div>
    </section>

</main>

<script>
    // jQuery(document).ready(function($) {
        
    //     if(document.location.search.length) {
    //         $('html, body').animate({
    //             scrollTop: ($("#events-search").offset().top - 95)
    //         }, 300);
    //     }

    //     $('.search-dates .date-label').on('click', function() {

    //         setTimeout(function() {
    //             $('#search-form').submit();
    //         }, 100);
    //     });

    //     $('.filters .buttons .apply').on('click', function() {
    //         setTimeout(function() {
    //             $('#search-form').submit();
    //         }, 100);
    //     });

    //     $('.filters .buttons .close').on('click', function() {
    //         $('.site-overlay').hide();
    //         $('.filters').css('display', 'none');
    //         $('.filters-toggle').toggleClass('toggled');
    //     });

    //     $('.filters .buttons .clear').on('click', function() {
    //         $('.cats input:checkbox').prop('checked', false); 
    //         $('.tags input:checkbox').prop('checked', false); 
    //     });

    //     $('.filter').on('click', function() {
    //         $(this).hide();
    //         var filter = $(this).data("filter");
    //         // console.log(filter);
    //         $('.cats #' + filter).prop('checked', false); 
    //         $('.tags #' + filter).prop('checked', false); 

    //         setTimeout(function() {
    //             $('#search-form').submit();
    //         }, 100);
    //     });

    //     $('.filters-toggle').on('click', function() {
    //         $('.site-overlay').show();
    //         $('.filters').css('display', 'block');
    //         $(this).toggleClass('toggled');
    //     });

    //     $('.site-overlay').on('click', function() {
    //         $(this).hide();
    //         $('.filters').css('display', 'none');
    //     });

    // });
</script>

<script src="https://cdn.jsdelivr.net/npm/@easepick/datetime@1.2.0/dist/index.umd.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/@easepick/core@1.2.0/dist/index.umd.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/@easepick/base-plugin@1.2.0/dist/index.umd.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/@easepick/range-plugin@1.2.0/dist/index.umd.min.js"></script>
<script>
    // var picker = new Lightpick({ 
    //     field: document.getElementById('datepicker'),
    //     singleDate: false,
    //     // footer: true,
    //     onSelect: function(start, end){
    //         var str = '';
    //         str += start ? start.format('Do MMMM YYYY') + ' to ' : '';
    //         str += end ? end.format('Do MMMM YYYY') : '...';
    //         document.getElementById('datepicker').innerHTML = str;

    //         if(str != '') {
    //             jQuery('.date-range-options label').addClass('hide');
    //             jQuery('.date-range-options #picker-clear').removeClass('hide');
    //         } else {
    //             jQuery('.date-range-options label').removeClass('hide');
    //             jQuery('.date-range-options #picker-clear').addClass('hide');
    //         }
    //     }
    // });

    const picker = new easepick.create({
        element: document.getElementById('datepicker'),
        css: [
            'https://cdn.jsdelivr.net/npm/@easepick/core@1.2.0/dist/index.css',
            'https://cdn.jsdelivr.net/npm/@easepick/range-plugin@1.2.0/dist/index.css',
        ],
        plugins: ['RangePlugin'],
        zIndex: 100,
        // autoApply: false,
        setup(picker) {
            picker.on('select', (e) => {
                var datePicked = picker.getDate();
                if(datePicked != '') {
                    jQuery('.date-range-options label').addClass('hide');
                    jQuery('.date-range-options #picker-clear').removeClass('hide');
                    jQuery('.search-dates input').attr('checked', false);
                    eventFormSubmit();
                }
            })
        }
    });

    jQuery(function($) {
        
        if(document.location.search.length) {
            $('html, body').animate({
                scrollTop: ($("#events-search").offset().top - 95)
            }, 300);
        }

        $('.search-dates .date-label').on('click', function() {
            setTimeout(function() {
                $('#search-form').submit();
            }, 100);
        });

        $('.filters .buttons .apply').on('click', function() {
            eventFormSubmit();
        });

        $('.filters .buttons .close').on('click', function() {
            $('.site-overlay').hide();
            $('.filters').css('display', 'none');
            $('.filters-toggle').toggleClass('toggled');
        });

        $('.filters .buttons .clear').on('click', function() {
            $('.cats input:checkbox').prop('checked', false); 
            $('.tags input:checkbox').prop('checked', false); 
        });

        $('.filter').on('click', function() {
            $(this).hide();
            var filter = $(this).data("filter");
            // console.log(filter);
            $('.cats #' + filter).prop('checked', false); 
            $('.tags #' + filter).prop('checked', false); 

            eventFormSubmit();
        });

        $('.filters-toggle').on('click', function() {
            $('.site-overlay').show();
            $('.filters').css('display', 'block');
            $(this).toggleClass('toggled');
        });

        $('.site-overlay').on('click', function() {
            $(this).hide();
            $('.filters').css('display', 'none');
        });

        $('#picker-clear').on('click', function() {
            picker.clear();
            jQuery('.date-range-options label').removeClass('hide');
            jQuery('.date-range-options #picker-clear').addClass('hide');
        });

        $('#event-name').on('keypress', function(e) {
            var code = e.keyCode || e.which;
            console.log(code);
            if(code == 13) {
                eventFormSubmit();
            }
        });

    });

    function eventFormSubmit() {
        // var pickerStartDate = picker.getStartDate();
        // console.log(pickerStartDate);
        // if(pickerStartDate == null) {
        //     jQuery('#datepicker').remove();
        //     console.log('no value');
        // }
        setTimeout(jQuery('#search-form').submit(), 100);
    }
</script>

<?php get_footer();


function rangeDate($datestr, $time_period) {
    date_default_timezone_set (date_default_timezone_get());
    $dt = strtotime ($datestr);

    if($time_period == 'week') {
        return array (
            "start" => date ('N', $dt) == 1 ? date ('Y-m-d', $dt) : date ('Y-m-d', strtotime ('last monday', $dt)),
            "end" => date('N', $dt) == 7 ? date ('Y-m-d', $dt) : date ('Y-m-d', strtotime ('next sunday', $dt))
        );
    } elseif($time_period == 'month') {
        return array (
            "start" => date ('Y-m-d', strtotime ('first day of this month', $dt)),
            "end" => date ('Y-m-d', strtotime ('last day of this month', $dt))
        );
    }
    
}